# rtc_driver.c File Reference

XMEGA RTC driver source file. More...

`#include "rtc_driver.h"`
Include dependency graph for rtc_driver.c:

Go to the source code of this file.

## Functions
void | RTC_Initialize (uint16_t period, uint16_t count, uint16_t compareValue, RTC_PRESCALER_t prescaler)
| This function initializes the RTC with period, initial count, compare value and clock prescaler.
void | RTC_SetAlarm (uint16_t alarmTimeout)
| This function sets a timeout alarm.
void | RTC_SetCompareIntLevel (RTC_COMPINTLVL_t intLevel)
| This function sets the RTC compare interrupt level.
void | RTC_SetIntLevels (RTC_OVFINTLVL_t ovfIntLevel, RTC_COMPINTLVL_t compIntLevel)
| This function sets both compare and overflow interrupt levels in one go.
void | RTC_SetOverflowIntLevel (RTC_OVFINTLVL_t intLevel)
| This function sets the RTC overflow interrupt level.
void | RTC_SetPrescaler (RTC_PRESCALER_t prescaler)
| This function sets a new RTC clock prescaler value.

## Detailed Description

XMEGA RTC driver source file.

This file contains the function implementations the XMEGA RTC driver.

The driver is not intended for size and/or speed critical code, since most functions are just a few lines of code, and the function call overhead would decrease code performance. The driver is intended for rapid prototyping and documentation purposes for getting started with the 16 bit XMEGA RTC module.

For size and/or speed critical code, it is recommended to copy the function contents directly into your application instead of making a function call.

Application note:
  AVR1314: Using the XMEGA Real Time Counter

Documentation
  For comprehensive code documentation, supported compilers, compiler settings and supported devices see readme.html

Author:
  Atmel Corporation: http://www.atmel.com
  Support email: avr@atmel.com

Revision
  2770

Date
  2009-09-11 16:55:22 +0800 (Fri, 11 Sep 2009)

Copyright (c) 2008, Atmel Corporation All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. The name of ATMEL may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Definition in file rtc_driver.c.

## Function Documentation

void RTC_Initialize | ( | uint16_t | period,
|  | uint16_t | count,
|  | uint16_t | compareValue,
|  | RTC_PRESCALER_t | prescaler |
| ) |  |  |

This function initializes the RTC with period, initial count, compare value and clock prescaler.

All the synchronized registers are written at the same time to save time. The program code need to check if the RTC is busy before calling this function. The RTC_Busy() function can be used to do this.

Parameters:

  | period | RTC period. Topvalue = Period - 1.
  | count | Initial RTC count.
  | compareValue | Compare value.
  | prescaler | Clock prescaler setting.

Definition at line 74 of file rtc_driver.c.

    00078 {
    00079         RTC.PER = period - 1;
    00080         RTC.CNT = count;
    00081         RTC.COMP = compareValue;
    00082         RTC.CTRL = ( RTC.CTRL & ~RTC_PRESCALER_gm ) | prescaler;
    00083 }

void RTC_SetAlarm | ( | uint16_t | alarmTimeout | ) |

This function sets a timeout alarm.

This function sets a timeout alarm by adding the timeout to the current count value. If the resulting alarm value is larger than the RTC period value, it will wrap around. An RTC compare interrupt will be triggered¨ after the specified timeout.

Note:
  The program code needs to check if the RTC is busy before calling this function. The RTC_Busy() function can be used to do this.
  The timeout must be less than the timer period. The timeout should not be set too low, as the timeout may be missed, depending on CPU speed.

Parameters:

  | alarmTimeout | Timeout time in RTC clock cycles (scaled).

Definition at line 137 of file rtc_driver.c.

    00138 {
    00139         /* Calculate compare time. */
    00140         uint16_t compareValue = RTC.CNT + alarmTimeout;
    00141
    00142         /* Wrap on period. */
    00143         if (compareValue > RTC.PER){
    00144                 compareValue -= RTC.PER;
    00145         }
    00146
    00147         /* Add the timeout value to get the absolute time of the alarm. */
    00148         RTC.COMP = compareValue;
    00149 }

void RTC_SetCompareIntLevel | ( | RTC_COMPINTLVL_t | intLevel | ) |

This function sets the RTC compare interrupt level.

Parameters:

  | intLevel | The compare interrupt level.

Definition at line 100 of file rtc_driver.c.

    00101 {
    00102         RTC.INTCTRL = ( RTC.INTCTRL & ~RTC_COMPINTLVL_gm ) | intLevel;
    00103 }

void RTC_SetIntLevels | ( | RTC_OVFINTLVL_t | ovfIntLevel,
|  | RTC_COMPINTLVL_t | compIntLevel |
| ) |  |  |

This function sets both compare and overflow interrupt levels in one go.

Parameters:

  | ovfIntLevel | The overflow interrupt level.
  | compIntLevel | The compare interrupt level.

Definition at line 112 of file rtc_driver.c.

    00114 {
    00115         RTC.INTCTRL = ( RTC.INTCTRL &
    00116                       ~( RTC_COMPINTLVL_gm | RTC_OVFINTLVL_gm ) ) |
    00117                       ovfIntLevel |
    00118                       compIntLevel;
    00119 }

void RTC_SetOverflowIntLevel | ( | RTC_OVFINTLVL_t | intLevel | ) |

This function sets the RTC overflow interrupt level.

Parameters:

  | intLevel | The overflow interrupt level.

Definition at line 90 of file rtc_driver.c.

    00091 {
    00092         RTC.INTCTRL = ( RTC.INTCTRL & ~RTC_OVFINTLVL_gm ) | intLevel;
    00093 }

void RTC_SetPrescaler | ( | RTC_PRESCALER_t | prescaler | ) |

This function sets a new RTC clock prescaler value.

Note:
  The program code need to check if the RTC is busy before calling this function. The RTC_Busy() function can be used to do this.

Parameters:

  | prescaler | Clock prescaler setting.

Definition at line 159 of file rtc_driver.c.

    00160 {
    00161         RTC.CTRL = ( RTC.CTRL & ~RTC_PRESCALER_gm ) | prescaler;
    00162 }